import { INIT_PAYMENTS_JOURNALS, SELECT_JOURNAL, RESET_JOURNALS, CALCULATE_CURRENCY_TOTAL } from '@/constants/actionTypes'
import { SET_JOURNALS, SET_LOADING_JOURNALS, SET_SELECTED_JOURNAL, SET_CURRENCY_JOURNAL } from '@/constants/mutationTypes'

const initialState ={
    journals: [],
    loadingJournal: false,
    selectedJournal: null,
    currencyJournal: []
}
const state = {
    journals: initialState.journals,
    loadingJournal: initialState.loadingJournal,
    selectedJournal: initialState.selectedJournal,
    currencyJournal: initialState.currencyJournal
}
const getters = {
    /**
     * [journals description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    journals(state) {
        return state.journals
    },
    /**
     * [loadingJournal description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    loadingJournal(state) {
        return state.loadingJournal
    },
    /**
     * [selectedJournal description]
     * @method selectedJournal
     * @param  {[type]}        state [description]
     * @return {[type]}              [description]
     */
    selectedJournal (state) {
        return state.selectedJournal
    },
    /**
     * [currencyJournal description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    currencyJournal (state) {
        return state.currencyJournal
    }

}

const mutations = {
    /**
     * [journals description]
     * @param  {[type]} state [description]
     * @param  {[type]} payload [description]
     */
    [SET_JOURNALS] (state, payload) {
        state.journals = payload
    },
    /**
     * [loadingJournal description]
     * @param  {[type]} state [description]
     * @param  {[type]} payload [description]
     */
    [SET_LOADING_JOURNALS] (state, payload) {
        state.loadingJournal = !!payload
    },
    /**
     * [selectedJournal description]
     * @type {[type]}
     * @param  {[type]} state [description]
     * @param  {[type]} payload [description]
     */
    [SET_SELECTED_JOURNAL] (state, payload) {
        state.selectedJournal = payload
    },
    /**
     * [currencyJournal description]
     * @type {[type]}
     */
    [SET_CURRENCY_JOURNAL] (state, payload) {
        state.currencyJournal = payload
    }

}

const actions = {
    /**
     * [INIT_PAYMENTS_JOURNALS]
     * @param {*} param0
     * @param {*} payload
     */
    [INIT_PAYMENTS_JOURNALS] ({ commit },payload ) {
        commit(SET_JOURNALS, payload)
        commit(SET_LOADING_JOURNALS, payload)
    },
    /**
     * [SELECT_JOURNAL]
     * @param {*} param0
     * @param {*} payload
     */
    [SELECT_JOURNAL] ({ commit, dispatch, getters },payload ) {
        let currency = []
        commit(SET_SELECTED_JOURNAL, payload)

        dispatch(CALCULATE_CURRENCY_TOTAL, payload)

        if (payload.currency.id){
            currency = payload.currency
        } else {
            currency = getters.currencyCompany
        }

        commit(SET_CURRENCY_JOURNAL, currency)
    },
    [RESET_JOURNALS] ({ commit }) {
        commit(SET_JOURNALS, [] )
        commit(SET_SELECTED_JOURNAL, null )

    }

}

export default {
    state,
    getters,
    mutations,
    actions
}
